<dom-module id="raphael-rectmovable-create">
  <template>
    <style>
    </style>
    <h2>Create movable rect</h2>
    <div id="rectmovable-create"></div>
  </template>

  <script>
    Polymer({

      is: 'raphael-rectmovable-create',
      ready: function () {

        this.paper = Raphael(
          "rectmovable-create", "100%", 50
        );

      },
      listeners: {
        'track':'track'
      },
      track: function (e) {
        // if (e.target.nodeName !== "svg") {
        //   return;
        // }
        switch(e.detail.state) {
          case 'start':
            this.rectangle = this.paper.rect(
              e.detail.x, 0, 0, 50, 10
            ).attr (
              {
                fill: "#f00",
                stroke: "#fff",
                opacity: "0.2"
              }
            );
            break;
          case 'track':
            this.rectangle.attr({width: e.detail.dx});
            break;
          case 'end':
            this.rectangle.drag (
              function (dx, dy, x, y, event) {
                if (this.command === "scaleright") {
                  var newwidth = this.owidth + dx;
                  if (newwidth > 50) {
                    this.attr({width: this.owidth + dx});
                  }
                } else if (this.command === "scaleleft"){
                  var newwidth = this.owidth - dx;
                  if (newwidth > 50) {
                    this.attr({width: this.owidth - dx, x: this.ox + dx});
                  }
                } else { // drag
                  this.attr({x: this.ox + dx});
                }
                event.stopPropagation();
              },
              function (x, y, event) {
                if ( x - this.attr("x") < this.attr("width")/4 ) {
                  this.command = "scaleleft";
                } else if ( x - this.attr("x") > 3*this.attr("width")/4 ) {
                  this.command = "scaleright";
                } else {
                  this.command = "drag"
                }
                this.owidth = this.attr("width");
                this.ox = this.attr("x");
                event.stopPropagation();
              }
            );
            break;
        }
      }

    });
  </script>
</dom-module>
